// (c) by Stefan Roettger, licensed under MIT license

#ifndef GLVERTEX_FORMATS_H
#define GLVERTEX_FORMATS_H

#include "glvertex_texture.h"
#include "glvertex_pnmformat.h"
#include "glvertex_rawformat.h"
#include "glvertex_objformat.h"

inline GLuint lglLoadTexture(std::string filename)
{
   unsigned char *img = NULL;
   int twidth = 0, theight = 0, tcomps = 0;
   GLuint texid = 0;

   img = lglReadPnmImage(filename, &twidth, &theight, &tcomps);
   if (!img) img = lglLoadRawImage(filename, &twidth, &theight, &tcomps);

   if (img)
   {
      if (tcomps == 1)
         texid = lglCreateMipmap2D(twidth,theight, LGL_LUMINANCE,img);
      else if (tcomps == 3)
         texid = lglCreateMipmap2D(twidth,theight, LGL_RGB,img);
      else if (tcomps == 4)
         texid = lglCreateMipmap2D(twidth,theight, LGL_RGBA,img);

      free(img);
   }

   return(texid);
}

#endif
