# libMini header and module list

SET(MINI_HDRS
   mini.h
   minidefs.h minibase.h
   minicore.h minicoreP.h
   miniOGL.h miniOGLP.h
   miniARB.h
   minivec.h minimtx.h
   minidyna.h minisort.h
   minikeyval.h minikdtree.h
   ministring.h minilog.h
   miniref.h mininode.h mininodes.h
   mininode_geom.h mininode_teapot.h
   mininode_path.h mininode_clod.h
   miniv3f.h miniv3d.h miniv4f.h miniv4d.h
   minimath.h minicomplex.h minicrypt.h
   glslmath.h glvertex.h
   mini3D.h miniwls.h
   mininoise.h minimpfp.h
   minitime.h minirgb.h minicrs.h
   miniio.h minidir.h minidds.h
   ministub.h minitile.h miniload.h
   minicoord.h minimeas.h
   minicurve.h minipath.h minixml.h
   miniclod.h miniwarp.h minicam.h
   minilayer.h miniterrain.h miniearth.h
   minicache.h minishader.h
   miniray.h ministrip.h
   minipoint.h minitext.h
   minisky.h miniglobe.h
   geoid.h wmm.h
   minitree.h minipano.h
   minibrick.h minilod.h
   minislicer.h
   minigeom.h minimesh.h minibspt.h miniproj.h
   pnmbase.h pnmsample.h
   rawbase.h rekbase.h
   database.h datafill.h
   datacloud.h datacache.h datagrid.h
   datacalc.h dataparse.h
   lunascan.h lunaparse.h lunacode.h
   lunafunctor.h
   mini_core.h mini_extra.h mini_format.h
   mini_generic.h mini_gfx.h
   mini_luna.h mini_math.h mini_object.h
   mini_tileset.h mini_util.h mini_volume.h
   )

SET(MINI_SRCS
   mini.cpp
   miniOGL.cpp miniARB.cpp
   miniv3f.cpp miniv3d.cpp miniv4f.cpp miniv4d.cpp
   minimath.cpp minicrypt.cpp
   mini3D.cpp miniwls.cpp
   mininoise.cpp minimpfp.cpp
   minitime.cpp minirgb.cpp minicrs.cpp
   miniio.cpp minidir.cpp minidds.cpp
   ministub.cpp minitile.cpp miniload.cpp
   minicoord.cpp minimeas.cpp
   minicurve.cpp minipath.cpp minixml.cpp
   miniclod.cpp miniwarp.cpp minicam.cpp
   minilayer.cpp miniterrain.cpp miniearth.cpp
   minicache.cpp minishader.cpp
   miniray.cpp ministrip.cpp
   minipoint.cpp minitext.cpp
   minisky.cpp miniglobe.cpp
   geoid.cpp wmm.cpp
   minitree.cpp minipano.cpp
   minibrick.cpp minilod.cpp
   minimesh.cpp minibspt.cpp miniproj.cpp
   mininodes.cpp mininode_teapot.cpp
   mininode_path.cpp mininode_clod.cpp
   minilog.cpp
   pnmbase.cpp pnmsample.cpp
   rawbase.cpp rekbase.cpp
   database.cpp datafill.cpp
   datacloud.cpp datacache.cpp datagrid.cpp
   datacalc.cpp dataparse.cpp
   lunascan.cpp lunaparse.cpp lunacode.cpp
   lunafunctor.cpp
   )

SET(MINISFX_HDRS
   miniscene.h miniview.h
   threadbase.h curlbase.h
   jpegbase.h pngbase.h zlibbase.h squishbase.h greycbase.h
   dataconv.h miniimg.h
   mini_sfx.h
   qt_viewer.h
   )

SET(MINISFX_SRCS
   miniscene.cpp miniview.cpp
   threadbase.cpp curlbase.cpp
   jpegbase.cpp pngbase.cpp zlibbase.cpp squishbase.cpp greycbase.cpp
   dataconv.cpp miniimg.cpp
   )

IF (NOT WIN32)
   IF (MINI_BUILD_TYPE MATCHES RELEASE)
      SET_SOURCE_FILES_PROPERTIES(greycbase.cpp COMPILE_FLAGS -O) # -O3 takes too long
   ENDIF (MINI_BUILD_TYPE MATCHES RELEASE)
ENDIF (NOT WIN32)
